require 'sketchup.rb'
class Sketchup::Selection
	def faces
	  find_all {|e| e.typename == "Face"}
	end
end
class AutoUnfoldXY

	def initialize
	  @@selected_faces = []
	  @@bas_sel=[]
	  @@state=0
	  @@face1 = []
	  @@face2 = []
	end #initialize
	def activate
		@@selected_faces =[]
		@@bas_sel= Sketchup.active_model.selection.faces
		Sketchup.active_model.selection.clear
		@@msg = @@bas_sel.length.to_s + " faces selected for unfolding. Select first face "
		Sketchup.set_status_text @@msg
	end #activate
	def onMouseMove(flags, x, y, view)
		if @@face1.length == 0
				Sketchup.set_status_text "AutoUnfold:Select first face to unfold."
				return
		end
		if @@face1.length == 1
				Sketchup.set_status_text "Select second face."
				return
		end
	end # onMouseMove
	def onLButtonDown(flags, x, y, view)
		ph = Sketchup.active_model.active_view.pick_helper
		ph.do_pick x, y
		ref = ph.best_picked
		if ref.nil?
			Sketchup.active_model.selection.clear
			Sketchup.set_status_text "AutoUnfold:Select face to unfold."
			return
		end #ifnil
		if( ref.typename == "Face" )
			if @@face1.length == 0
				@@state = 1
				@@face1 << ref
				Sketchup.active_model.selection.add ref
				Sketchup.set_status_text "Select second face"
				return
			end #if face1.length = 0
			if @@face1.length == 1
				@@state = 2
				@@face2 << ref
				Sketchup.set_status_text " Unroll in progress"
				Sketchup.active_model.start_operation "Unfold"
				st = ufold(@@bas_sel,@@face1,@@face2)
			end #if face1.length = 1
			if st
				Sketchup.active_model.selection.add @@face1
			end # if st is not nil
		end # if face picked
		Sketchup.active_model.commit_operation
	end # onLeftButtonDown
	def ufold(bas_sel,face1,face2)
		#select all from basis selection that are coplanar with face1
		cop_faces = []
		bas_sel.each do |f|
			if f.normal == face1[0].normal
				cop_faces << f
			end #if faces coplanar
		end #each bas_sel
		angle = face1[0].normal.angle_between face2[0].normal
		axis = Geom::intersect_plane_plane(face1[0].plane, face2[0].plane)
		#unfold first face to face2
		g = Sketchup.active_model.entities.add_group(cop_faces)
		g.transform! Geom::Transformation.rotation(axis[0], axis[1],angle)
		g.explode
		#set face2 as face1
		face1[0] = face2[0]
		cop_faces = []
		bas_sel.each do |f|
			if f.normal == face1[0].normal
				cop_faces << f
			end # if faces coplanar
		end #each bas_sel
		until cop_faces.length == bas_sel.length
			#find adjacent face to all coplanar faces
			cop_edges = []
			cop_faces.each do |f|
				f.edges.each do |e|
					cop_edges << e
				end # each cop_faces edges
			end # each cop_faces
			adj_faces = []
			cop_edges.each do |e|
				e.faces.each do |f|
					if bas_sel.include?(f)
						adj_faces << f
					end # if faces is in bas_sel
				end # each face
			end # each edge
			adj_faces = adj_faces - cop_faces
			#set first adj face as face2
			face2[0]=adj_faces[0]
			angle=[]
			axis=[]
			angle = face1[0].normal.angle_between face2[0].normal
			axis = Geom::intersect_plane_plane(face1[0].plane, face2[0].plane)
			#unfold first face to face2
			g = Sketchup.active_model.entities.add_group(cop_faces)
			g.transform! Geom::Transformation.rotation(axis[0], axis[1], angle)
			g.explode
			#set face2 as face1
			face1[0]=face2[0]
			#select all from basis selection that are coplanar with face1 
			cop_faces = []
			bas_sel.each do |f|
				if f.normal == face1[0].normal
					cop_faces<<f
				end
			end
			@@msg = "Unroll in progress : " + cop_faces.length.to_s + " / " + bas_sel.length.to_s
			Sketchup.set_status_text @@msg
		end
		#unfold all faces to plane xy
		angle=[]
		axis=[]
		angle = bas_sel[0].normal.angle_between [0,0,1]
		axis = Geom::intersect_plane_plane(bas_sel[0].plane, [0,0,1,0])
		g = Sketchup.active_model.entities.add_group(bas_sel)
		g.transform! Geom::Transformation.rotation(bas_sel[0].vertices[0].position, axis[1], angle)
		g.explode
	end
end #class Autounfold
class AutoUnfold

	def initialize
	  @@selected_faces = []
	  @@bas_sel=[]
	  @@state=0
	  @@face1 = []
	  @@face2 = []
	end #initialize
	def activate
		@@selected_faces =[]
		@@bas_sel= Sketchup.active_model.selection.faces
		Sketchup.active_model.selection.clear
		@@msg = @@bas_sel.length.to_s + " faces selected for unfolding. Select first face "
		Sketchup.set_status_text @@msg
	end #activate
	def onMouseMove(flags, x, y, view)
		if @@face1.length == 0
				Sketchup.set_status_text "AutoUnfold:Select first face to unfold."
				return
		end
		if @@face1.length == 1
				Sketchup.set_status_text "Select second face."
				return
		end
	end # onMouseMove
	def onLButtonDown(flags, x, y, view)
		ph = Sketchup.active_model.active_view.pick_helper
		ph.do_pick x, y
		ref = ph.best_picked
		if ref.nil?
			Sketchup.active_model.selection.clear
			Sketchup.set_status_text "AutoUnfold:Select face to unfold."
			return
		end #ifnil
		if( ref.typename == "Face" )
			if @@face1.length == 0
				@@state = 1
				@@face1 << ref
				Sketchup.active_model.selection.add ref
				Sketchup.set_status_text "Select second face"
				return
			end #if face1.length = 0
			if @@face1.length == 1
				@@state = 2
				@@face2 << ref
				Sketchup.set_status_text " Unroll in progress"
				Sketchup.active_model.start_operation "Unfold"
				st = ufold(@@bas_sel,@@face1,@@face2)
			end #if face1.length = 1
			if st
				Sketchup.active_model.selection.add @@face1
			end # if st is not nil
		end # if face picked
		Sketchup.active_model.commit_operation
	end # onLeftButtonDown
	def ufold(bas_sel,face1,face2)
		#select all from basis selection that are coplanar with face1
		cop_faces = []
		bas_sel.each do |f|
			if f.normal == face1[0].normal
				cop_faces << f
			end #if faces coplanar
		end #each bas_sel
		angle = face1[0].normal.angle_between face2[0].normal
		axis = Geom::intersect_plane_plane(face1[0].plane, face2[0].plane)
		#unfold first face to face2
		g = Sketchup.active_model.entities.add_group(cop_faces)
		g.transform! Geom::Transformation.rotation(axis[0], axis[1],angle)
		g.explode
		#set face2 as face1
		face1[0] = face2[0]
		cop_faces = []
		bas_sel.each do |f|
			if f.normal == face1[0].normal
				cop_faces << f
			end # if faces coplanar
		end #each bas_sel
		until cop_faces.length == bas_sel.length
			#find adjacent face to all coplanar faces
			cop_edges = []
			cop_faces.each do |f|
				f.edges.each do |e|
					cop_edges << e
				end # each cop_faces edges
			end # each cop_faces
			adj_faces = []
			cop_edges.each do |e|
				e.faces.each do |f|
					if bas_sel.include?(f)
						adj_faces << f
					end # if faces is in bas_sel
				end # each face
			end # each edge
			adj_faces = adj_faces - cop_faces
			#set first adj face as face2
			face2[0]=adj_faces[0]
			angle=[]
			axis=[]
			angle = face1[0].normal.angle_between face2[0].normal
			axis = Geom::intersect_plane_plane(face1[0].plane, face2[0].plane)
			#unfold first face to face2
			g = Sketchup.active_model.entities.add_group(cop_faces)
			g.transform! Geom::Transformation.rotation(axis[0], axis[1], angle)
			g.explode
			#set face2 as face1
			face1[0]=face2[0]
			#select all from basis selection that are coplanar with face1 
			cop_faces = []
			bas_sel.each do |f|
				if f.normal == face1[0].normal
					cop_faces<<f
				end
			end
			@@msg = "Unroll in progress : " + cop_faces.length.to_s + " / " + bas_sel.length.to_s
			Sketchup.set_status_text @@msg
		end
	end
end #class Autounfold
menu_name = "AutoUnfold and set to XY plane"
menu_name2 = "AutoUnfold and leave in plane of last face"
#menu_name = File.basename(__FILE__)
unless file_loaded?(menu_name)
	UI.menu("Plugins").add_separator
	ausubmenu=UI.menu("Plugins").add_submenu("Autounfold")
	ausubmenu.add_item(menu_name) {
      Sketchup.active_model.select_tool AutoUnfoldXY.new
   }  
   file_loaded(menu_name)
end
unless file_loaded?(menu_name2)
	ausubmenu.add_item(menu_name2) {
      Sketchup.active_model.select_tool AutoUnfold.new
   } 
   file_loaded(menu_name2)
end
